/*
**	Program:	BTNC
**
**	Module:		General definitions
*/

#define	NewAtom(x)	calloc(1L, sizeof(x))
#define Last(s)	s[strlen(s)-1]
#define	HB		(BYTE)(1<<7);
		

#define	VERSION		"1.86"
#define	CTRL_Z		26

/*
** Allowed fist characters on line
*/

#define	LEGAL_CHARS ",ZzRrHhPpDd"

/*
**	Returncodes of ParseLine()
*/

#define	OK			0
#define	DOWN		1
#define	ABORT		2
#define	SKIP		3

/*
**	General structs
*/

typedef struct _ADDRESS
{
	UWORD			zone, net, node, point;
	
	struct _ADDRESS	*next;
} ADDRESS;

typedef struct _ADDLIST
{
	UWORD			tozone,
					toregion;
					
	BYTE			listfile[80];

/* Modified ---------------------------------- */

	BOOLEAN		dimension4; 
	BOOLEAN		new_3D_format;
	
/*-------------------------------------------- */	
	struct _ADDLIST	*next;
} ADDLIST;

typedef struct _POINTLIST
{
	ADDRESS			boss;
	
	BYTE			listfile[80];
	
	struct _POINTLIST	*next;
} POINTLIST;

/*
**	DOMAINS.BNL
*/

#define	MULTIZONE		0

typedef struct _DOMAIN
{
	BYTE			name[13],
					listfile[13];
	
	UWORD			zone;
	
	ULONG			startoffset,
					length;
} DOMAIN;

/*
**	INDEX.BNL
*/

#define	ZC			6
#define	RC			5
#define	HOST		4
#define	HUB			3
#define	NODE		2
#define	POINT		1

typedef struct _INDEX
{
	BYTE			type;
	UWORD			value;
} INDEX;

typedef struct _CINDEX
{
	BYTE			type;
	UWORD			value;
	ULONG			offset;
} CINDEX;

/*
**	NODEINFO.BNL
**
**	Modemtypes
*/

#define	HST		(1 << 0)
#define	PEP		(1 << 1)
#define	MNP		(1 << 2)
#define	V32		(1 << 3)
#define	V32B	(1 << 4)
#define	V42		(1 << 5)
#define	V42B	(1 << 6)
#define H16		(1 << 7)
#define	ZYX		(1 << 8)
#define Z19		(1 << 9)
#define	V32T	(1 << 10)
#define V34		(1 << 11)
#define ISDNA	(1 << 12)
#define ISDNB	(1 << 13)
#define ISDNC	(1 << 14)
#define	MAX		(1 << 15)

/*
**	System flags
*/

#define	MAILONLY	1U
#define	CM			2U
#define	NOARCMAIL	4U
#define	UNDIALABLE	8U

#define	BARKREQ		16U
#define	BARKUPDREQ	32U
#define	WAZOOREQ	64U
#define	WAZOOUPDREQ	128U

#define	PRIVATE		256U
#define	HOLD		512U

typedef struct _SYSTEM
{
	BYTE			sysname[34],
					location[30],
					operator[30],
					phone[40];
	
	UWORD			hubnode;
	
	BYTE			maxbaud;		/*	Baud/300	*/
	WORD			modemtype;
	
	UWORD			flags;
} SYSTEM;

/*
** Compressed system entry
*/

typedef struct _CSYSTEM
{
	UWORD			length;

	UWORD			hubnode;
	
	BYTE			maxbaud;		/*	Baud/300	*/
	WORD			modemtype;
	
	UWORD			flags;

	BYTE			code[134];

} CSYSTEM;

/*
**	Local domain specification
*/

typedef struct _DOMAINSPEC
{
	DOMAIN			dat;
	
	struct _DOMAINSPEC	*next;
} DOMAINSPEC;
