/*
**	Magic value for recognizing incoming messages:
*/

#define FIDO_MSG		'FM'		/* Magic value for identifying			*/
#define	FIDO_HELLO		'=?-/'		/* For handshake purpose (if necessary)	*/
#define	FIDO_HELLO_ACK	'=:-)'		/* Handshake acknowledge				*/

/*
**	ID's for the 'FROM'-field:
*/

#define FM_SEMPER		'SEMP'		/* Semper			*/
#define FM_AVALON		'AVAL'		/* Avalon shell 	*/
#define FM_MSGREADER	'MSGR'		/* e.g. LED 		*/
#define FM_TOSSER		'TOSS'		/* e.g. JetMail 	*/
#define FM_REQCOMPILER	'REQC'		/* RequestCompiler	*/
#define FM_NLCOMPILER	'NLST'		/* NodelistCompiler */
#define FM_OCTOPUS		'OCTP'		/* Octopus BBS		*/

/*
**	Currently supported SEMPER-TODO values:
*/

#define SEMP_RESCAN 	(1UL << 0)	/* Rescan outbound				*/
#define SEMP_READ_NLIST (1UL << 1)	/* Reread nodelist				*/
#define SEMP_READ_RQST	(1UL << 2)	/* Reread request index 		*/
#define SEMP_EXPORTER	(1UL << 3)	/* Executes the Export program	*/

/*
**	Currently supported AVALON-TODO values:
*/

#define AVAL_REQ		1UL 	  /* FileRequest				  */
#define AVAL_HATCH 		2UL 	  /* FileHatch					  */
#define AVAL_FIX		3UL 	  /* Areafix					  */
#define AVAL_AREAS 		4UL 	  /* Edit areas 				  */

/*
**	Currently supported OCTOPUS-TODO values:
*/
 
#define OCTO_M_LOCAL	 0x0001UL  /* Begin a local logon						  */
#define OCTO_M_WATCH	 0x0002UL  /* Open a View window when a connection exist  */
#define OCTO_M_MAILER	 0x0004UL  /* End Octopus after a connection (not needed) */
#define OCTO_M_NOHANGUP  0x0008UL  /* Don't raise the DTR signal for hangup 	  */
#define OCTO_M_STATUS	 0x0010UL  /* Request of Octopus Status					  */

/*
**	Return values for Octopus->Semper:
*/

#define OCTO_M_OK		 0x0010UL  /* Ok, ACK handshake message 		*/
#define OCTO_M_BUSY 	 0x0020UL  /* Octopus is busy yet				*/
#define OCTO_M_READY	 0x0040UL  /* Octopus is waiting (ready) now... */
#define OCTO_M_HELLO	 0x0080UL  /* Say Hello to Semper... :-)		*/


/* =============================================================== */


ULONG	CRC32_Update(UBYTE c, ULONG crc);
UWORD	CRC16_Update(UBYTE c, UWORD crc);
ULONG	CRC32_Block(ULONG crc, VOID *buffer, size_t len);
ULONG	CRC32_SmallBlk(ULONG crc, VOID *buffer, UWORD len);

VOID	SendAppMsg(BYTE *path, BYTE *file, BYTE *app, LONG sender, LONG action);

VOID	ReplaceChar(CONST BYTE s, CONST BYTE d, BYTE *string);

BOOLEAN	mergesort(VOID *array, ULONG elements, UWORD elemsize, WORD (*cmp)());
		/* liefert FALSE, falls nicht genuegend RAM vorhanden */

UWORD	CnvIntel(UWORD value);

BOOLEAN	GetCookie(LONG cookie, LONG *value);

BYTE	*stristr(CONST BYTE *string1, CONST BYTE *string2);